// sub.c

#include "iodefine.h"
#include "incmain.h"

#define	MAXRXBUF	100		/* Mobt@TCY	*/

volatile unsigned char *rxp, *rxbp, rxbuf[MAXRXBUF];	// VAMbuffer
volatile unsigned int CMT_Count;

// sci2 
// baud rate    9600    19200    38400    115.2k
//    SCEMR    0x0000   0x0000   0x0000   0x0080
//    SCBRR      77       38       19       12
void InitSCI2(void)
{
	unsigned short int sts;

	rxp = rxbp = rxbuf;             // receive buffer clear

	/* SCIF2X^oC */
	CPG.STBCR4.BIT.MSTP45 = 0;		/* SCIF2ւ̃NbNJn	*/

	/* SCIFxݒ */
	SCIF2.SCSCR.WORD    = 0x0000;	/* M~    TE=0,RE=0,CKE1=0 */
	SCIF2.SCFCR.WORD    = 0x0006;	/* MFIFZbg TFRST=1,RFRST=1 */
	sts = SCIF2.SCFSR.WORD;			/* MXe[^Xǂ */
	SCIF2.SCFSR.WORD   &= 0xff6eu;	/* ERADRABRK rbgNA */
	SCIF2.SCLSR.WORD   &= 0x0000;	/* ORER rbgNA */
	SCIF2.SCSMR.WORD    = 0x0000;	/* VAʐMtH[}bg CHR=0,PE=0,STOP=0,CKS=00(P/1) */
	SCIF2.SCSCR.BIT.CKE = 0x00;		/* NbN\[X̑I CKE[1:0]rbgݒ */
	SCIF2.SCEMR.WORD    = 0x0080;	/* {[h	*/
	SCIF2.SCBRR.BYTE    = 12;		/* ݒ */
	SCIF2.SCFCR.WORD    = 0x0000;	/* FIFORg[ TREG:8bytes RTRG:1bytes */

	/* @\[qݒ */
	PORT.PFCR0.BIT.PF2MD = 4;		/* PF2=RxD2 */
	PORT.PFCR0.BIT.PF1MD = 4;		/* PF1=TxD2 */

	SCIF2.SCSCR.WORD = 0x0070;		/* TIE=0,RIE=1,TE=1,RE=1, RIE=0 */

	/* SCIF2M荞݃x15 */
	INTC.IPR17.BIT._SCIF2 = 15;
}

/* sci2 Po */
void sputc2(char data)
{
    while( SCIF2.SCFSR.BIT.TDFE  == 0);
    SCIF2.SCFTDR.BYTE = data;		/* Mf[^ */
	SCIF2.SCFSR.BIT.TDFE = 1;
}

/* sci2 o */
void sputs2(char *str)
{
	unsigned char data;
	
	while( (data = *str++) != 0){	/* null܂ŏo */
	    sputc2(data);
	}
}

// sci2 16i\
void sputb2(unsigned char data)
{
    unsigned tmp;
	
	tmp = (data >> 4) & 0x0f; 
    if( tmp <= 9 ){
		sputc2( tmp + '0' );
	}else{
		sputc2( tmp + '7' );
	}
	tmp = data & 0x0f;
    if( tmp <= 9 ){
		sputc2( tmp + '0' );
	}else{
		sputc2( tmp + '7' );
	}
}	

// sci2 荞
void int_rx(void)
{
    unsigned char data;
	
	data = SCIF2.SCFRDR.BYTE;		/* Mf[^ǂݏo */
	SCIF2.SCFSR.BIT.RDF = 0;   //
	SCIF2.SCFSR.BIT.DR = 0;    //
	*rxp++ = data;
	if( rxp >= &rxbuf[MAXRXBUF-1] ){
		rxp = rxbuf;
	}
}

// sci2 data buffer chech
int stat_sci2(void)
{
	if( rxp != rxbp ){
	    return TRUE;
	}else{
		return FALSE;
	}
}

// sci2 data buffer PoCgo
unsigned char getc2(void)
{
	unsigned char data;

    data = *rxbp++;
	if( rxbp >= &rxbuf[MAXRXBUF-1] ){
		rxbp = rxbuf;
	}
	return data;
}

// RyA}b`^C}0 
void CMT0_Initialize(void)
{
	/*--- STBCR7ݒ CMTNbNJn ---*/
	CPG.STBCR7.BIT.MSTP72 = 0;
	/* RyA}b`^C}0 荞݃x15 */
	INTC.IPR10.BIT._CMT0 = 14;
	/*--- CMSTRݒ CMCNT0JEg~ ---*/
	CMT.CMSTR.BIT.STR0 = 0;
	/*--- CMCNT0ݒ 0NA ---*/
	CMT.CMCNT0.WORD = 0x0000;
	/*--- CMCSR0ݒ CMI NbNݒ[P/32] ---*/
	CMT.CMCSR0.WORD = 0x0041;
	/*--- CMCOR0ݒ ---*/
	CMT.CMCOR0.WORD = 7499;		// (10ms)

	CMT_Count = 0;
	/*--- CMSTRݒ CMCNT0JEgJn	---*/
	CMT.CMSTR.BIT.STR0 = 0x1;
}

// RyA}b`^C}0 荞ݏ
void CMT0_Interrupt(void)
{
	/*--- CMF 0NA ---*/
	CMT.CMCSR0.BIT.CMF = 0;
    CMT_Count++;

    SensePSW();	
}
